
// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
var nativePort = null; //null if not connected
var posX = 0.0;
var posY = 0.0;
var posZ = 0.0;

var button0;
var button1;
var button2;
var button3;

function sendNativeMessage(message) {
	if(nativePort)
		nativePort.postMessage(message);
}
function onNativeMessage(message) {

  if(contentPort)
		contentPort.postMessage(message);
	
	for(let i = 0;i < message.length;++i){
		if(message[i].cmd == "getPosition"){
				posX = message[i].x;
				posY = message[i].y;
				posZ = message[i].z;
				return;
			}
			if(message[i].cmd == "getButtons"){
				button0 = message[i].button0;
				button1 = message[i].button1;
				button2 = message[i].button2;
				button3 = message[i].button3;
				return;
			}
			if(message[i].cmd == "debug" || message[i].cmd == "error"){
				console.log(message[i]);
			}
	}
}

function onDisconnected() {
  console.log("Failed to connect: " + chrome.runtime.lastError.message);
  nativePort = null;
}
function connect() {
  var hostName = "de.philippsuniversity.hapticshost";
  console.log("Connecting to native messaging host <b>" + hostName + "</b>")
  nativePort = chrome.runtime.connectNative(hostName);
  nativePort.onMessage.addListener(onNativeMessage);
  nativePort.onDisconnect.addListener(onDisconnected);
}

  chrome.runtime.onInstalled.addListener(function() {
      console.log('extension installed.');
  });
  
function updatePopUpUI(){
	var views = chrome.extension.getViews({
		type: "popup"
	});
	for (var i = 0; i < views.length; i++) {
		var p = views[i].document.getElementById('fdValue_pos');
		if(p)
			p.innerHTML = "position: ("+posX + ","+ posY+","+posZ+")";
		var b = views[i].document.getElementById('fdValue_btn');
		if(b)
			b.innerHTML = "buttons: ("+button0 + ","+ button1+","+button2+","+button3+")";
		
		var c = views[i].document.getElementById('fdValue_connected');
		if(c){
			if(nativePort!=null)
				views[i].document.getElementById('fdValue_connected').innerHTML = "connected";
			else
				views[i].document.getElementById('fdValue_connected').innerHTML = "not connected";
		}
	}
}


chrome.runtime.onInstalled.addListener(function() {
	setInterval(updatePopUpUI,20);
	 
	setInterval(function() {
	  if(nativePort==null)
		  connect();
	}, 1000);
});


setInterval(updatePopUpUI,20);
	
setInterval(function() {
	if(nativePort==null)
		connect();
}, 1000);

var contentPort = null;

chrome.runtime.onConnect.addListener(function(port) {
  if(port.name == "forcedimensionextension"){
	contentPort = port;
	contentPort.onDisconnect.addListener(function(){ contentPort = null;});
  }
  
  
  //reaction to requiest
  port.onMessage.addListener(function(msg) {
	sendNativeMessage(msg);
  });
});
