#ifndef DEF_BEHAVIOURS_H
#define DEF_BEHAVIOURS_H

#include "Vec3.h"
#include <math.h>

#include "BehaviourProcessor.h"

using namespace std;

class BehaviourWait : public IBehaviour {

private:
	Vec3f waitPos;
	int waitCricles;
	float garbage;
	float vibrationAmplitude;
	BehaviourProcessor* b;

public:
	BehaviourWait(int circles, Vec3f waitPos, float vibrationAmplitude = 0.0f) {
		waitCricles = circles;
		this->waitPos = waitPos;
		this->vibrationAmplitude = vibrationAmplitude;
	}

	void SetBehaviourProcessor(BehaviourProcessor* b) {
		this->b = b;
	}

	bool Update() {
		b->MoveTo(waitPos, 10000.0, vibrationAmplitude,min((waitPos - *(b->currentPos)).length()*0.5f, 0.05f));
		waitCricles--;
		return waitCricles <= 0;
	}
};

class BehaviourMoveTo : public IBehaviour {

private:
	float stepSize;
	Vec3f targetPos;
	BehaviourProcessor* b;

public:
	BehaviourMoveTo(Vec3f targetPos, float stepSize = 0.02f) {
		this->stepSize = stepSize;
		this->targetPos = targetPos;
	}

	void SetBehaviourProcessor(BehaviourProcessor* b) {
		this->b = b;
	}

	bool Update() {
		return b->MoveTo(targetPos,10000.0f,1.0f,stepSize);
	}
};

#endif