// Copyright (C) Thorsten Thormaehlen

#ifndef DEF_RAY_H
#define DEF_RAY_H

  /*!
  \class Ray Ray.h
  \brief This class describes a ray in 3D space
  */

  class Ray
  {

  public :
    Vec3f origin;
    Vec3f direction;

  public :
    //! constructor
    Ray(const Vec3f &o, const Vec3f &d)
    { 
      origin = o;
      direction = d;
    } 

    //!constructor
    Ray() {}
  };

  /*!
  \class RayHit Ray.h
  \brief This class hold all the information for the intersection point of a ray with a 3D object
  */

  class RayHit
  {

  public :
    Ray ray;
    Vec3f hitPoint;

  public :
    //!constructor
    RayHit() {}
  };

#endif
