var posMin = -0.05;
var posMax = 0.05;

var posX = 0.0;
var posY = 0.0;
var posZ = 0.0;

var forceX = 0.0;
var forceY = 0.0;
var forceZ = 0.0;

var canvas = document.getElementById("canvas");

var ctx = canvas.getContext("2d");

//obstaclc data in worldSpace
var obstalceX = canvas.width / 2.0;
var obstalceY = canvas.height / 2.0;
var obstalceRadius = 50.0;

//coursor in worldSpace
var coursorX = 0.0;
var coursorY = 0.0;

//fource in worldCoordinates (for betting understanding)
var coursorForceX = 0.0;
var coursorForceY = 0.0;
var forceFactor = 0.6;
var forceSmoothing = 0.0;

function calc(){
	coursorX = (posY-posMin)/(posMax-posMin) * canvas.width;
	coursorY = (-posZ-posMin)/(posMax-posMin) * canvas.height;
	
	var diffX = coursorX-obstalceX;
	var diffY = coursorY-obstalceY;
	var diffLength = Math.sqrt(diffX*diffX+diffY*diffY);
	var depth = obstalceRadius-diffLength;
	
	var newForceX;
	var newForceY;
	
	if(depth>0 && diffLength>0.01){
		newForceX = diffX / diffLength*forceFactor * depth;
		newForceY = diffY / diffLength*forceFactor * depth;
	}else{
		newForceX = 0.0;
		newForceY = 0.0;
	}
	coursorForceX = coursorForceX*forceSmoothing +newForceX*(1.0-forceSmoothing);
	coursorForceY = coursorForceY*forceSmoothing +newForceY*(1.0-forceSmoothing);
	
	forceY = coursorForceX;
	forceZ = -coursorForceY;
}

function draw(){
	//drawObstacle
	ctx.clearRect ( 0 , 0 , canvas.width , canvas.height )
	
	ctx.fillStyle = "#FFFFFF";
	ctx.beginPath();
	ctx.arc(obstalceX, obstalceY, obstalceRadius, 0, 2 * Math.PI, false);
	ctx.lineWidth = 3;
	ctx.strokeStyle = '#000000';
	ctx.stroke();
	
	//drawCoursor
	ctx.fillStyle = "#FF0000";
	ctx.beginPath();
	ctx.arc(coursorX, coursorY, 5, 0, 2 * Math.PI, false);
	ctx.lineWidth = 2;
	ctx.strokeStyle = '#FF0000';
	ctx.stroke();
	
	if(position){
		coursorX = (position.y-posMin)/(posMax-posMin) * canvas.width;
		coursorY = (-position.z-posMin)/(posMax-posMin) * canvas.height;
	}
}	

function getConnection(){
	if(connection>=0)
		document.getElementById('connection').innerHTML = "connection state : CONNECTED ("+connection+")";
	else
		document.getElementById('connection').innerHTML = "connection state : NOT CONNECTED";
}

setInterval(draw,16);
setInterval(getConnection,100);
