var resizeHandle;
var resizeObjectTop;
var resizeObjectButtom;

var resizingVertical = false;
var resizingHorizontal = false;

var codeAreaActivated = false;
var codeEditor;
var codeEditorIsFocused = false;

init();


function init() {
    verticalResizeHadle =  document.getElementById( 'verticalHandle' );
    rightContainer = document.getElementById( 'viewContainer' );
    objectView  = document.getElementById( 'container' );

    codeContainer  = document.getElementById( 'codeContainer' );
    codeArea  = document.getElementById( 'codeArea' );

    codeEditor = ace.edit("codeArea"); 
    codeEditor.on("focus", function() { codeEditorIsFocused = true;});
    codeEditor.on("blur", function() { codeEditorIsFocused = false; });
    codeEditor.setTheme("ace/theme/monokai");
    codeEditor.session.setMode("ace/mode/javascript");
    codeEditor.setOptions({
        enableBasicAutocompletion: true
    });

    //codeEditor.aria-label="code editor";

    debugArea = document.getElementById( 'debugArea' );

    horizontalResizeHadle =  document.getElementById( 'horizontalHandle' );
}

function adjustCodeAreaHorizontal(widthPercent){
    rightContainer.style.width = 100.0-widthPercent+ '%';
    codeContainer.style.width = widthPercent+'%';
    codeArea.style.width = 'calc('+100.0-100.0*widthPercent+"% - 14px)";
    onWindowResize();
    codeEditor.resize();
}

function adjustCodeAreaVertical(heightPercent){
    objectView.style.height = heightPercent*1.0/0.8+ '%';
    debugArea.style.height = (100.0-heightPercent)+'%';
    onWindowResize();
    codeEditor.resize();
}

function adjustCodeArea(widthPercent,heightPercent){
    rightContainer.style.width = 100.0-widthPercent+ '%';
    codeContainer.style.width = widthPercent+'%';
    codeArea.style.width = 'calc('+100.0-100.0*widthPercent+"% - 14px)";

    objectView.style.height = heightPercent*1.0/0.8+ '%';
    debugArea.style.height = (100.0-heightPercent)*1.0/0.8+'%';
    onWindowResize();
    codeEditor.resize();
}

function activateCodeArea(activate){
    if(!activate){
        adjustCodeArea(0,100);
    }else{
        adjustCodeArea(50,80);
    }
    codeAreaActivated = activate;
}

verticalResizeHadle.addEventListener("mousedown", function( event ) {
	resizingVertical = true;
});
horizontalResizeHadle.addEventListener("mousedown", function( event ) {
	resizingHorizontal = true;
});

window.addEventListener("mouseup", function( event ) {
    resizingVertical = false;
    resizingHorizontal = false;
});

window.addEventListener("mousemove", function(event){
    //resize when clicking on the resize handle


    event = event || window.event;
    var eventMouse = {x:0,y:0};
    eventMouse.x = ( event.clientX / window.innerWidth );
	eventMouse.y = ( event.clientY / window.innerHeight );
    
    if(resizingVertical){
        var widthPercent = Math.min(window.innerWidth,Math.max(20,eventMouse.x*window.innerWidth))/window.innerWidth*100.0;
        adjustCodeAreaHorizontal(widthPercent);
    }

    if(resizingHorizontal){
        var heightPercent = Math.min(window.innerHeight-10,Math.max(0,eventMouse.y*window.innerHeight))/window.innerHeight*100.0;
        adjustCodeAreaVertical(heightPercent);
    }
}, false);


//activateCodeArea(false);