var AudioContext = window.AudioContext || window.webkitAudioContext;
var audioCtx = new AudioContext();
var listener = audioCtx.listener;
listener.forwardX.value = 0;
listener.forwardY.value = 0;
listener.forwardZ.value = -1;
listener.upX.value = 0;
listener.upY.value = 1;
listener.upZ.value = 0;
listener.positionX.value = 0;
listener.positionY.value = 0;
listener.positionZ.value = 0;
  
var panner = audioCtx.createStereoPanner();
panner.connect(audioCtx.destination);
var gainNode = audioCtx.createGain();
gainNode.gain.value = 0;
gainNode.connect(panner);
			
function createPositionalAudio(soundFile){
	var source = audioCtx.createBufferSource();
	request = new XMLHttpRequest();
	request.open('GET', soundFile, true);

	request.responseType = 'arraybuffer';

	request.onload = function() {
		var audioData = request.response;

		audioCtx.decodeAudioData(audioData, function(buffer) {

			source.buffer = buffer;		
			source.connect(gainNode);			
			source.loop = true;
			source.start(0);
		  },

		  function(e){
			console.log("Error with decoding audio data" + e.err);
		  });
	};

	request.send();
}

var count = 0;
function updatePannerPosition(xPos,distance){
	panner.pan.linearRampToValueAtTime(Math.max(-1.0,Math.min(1.0,xPos*0.5)), audioCtx.currentTime+0.1);
	gainNode.gain.linearRampToValueAtTime(Math.max(0.0,Math.min(1.0,Math.pow(0.3,distance-cursorSize)*0.6))*soundController.masterVolume, audioCtx.currentTime+0.1);
}

